Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_branch_complete.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_branch_complete.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_branch_complete.cpp	(revision 88)
@@ -0,0 +1,49 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::genMealy_branch_complete"
+  void Front_end_Glue::genMealy_branch_complete (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
+      {
+        Tcontrol_t miss_prediction = PORT_READ(in_BRANCH_COMPLETE_PREDICTION_UNIT_MISS_PREDICTION [i]);
+        PORT_WRITE(out_BRANCH_COMPLETE_MISS_PREDICTION               [i],miss_prediction);
+        PORT_WRITE(out_BRANCH_COMPLETE_CONTEXT_STATE_MISS_PREDICTION [i],miss_prediction);
+
+        Tcontrol_t val = PORT_READ(in_BRANCH_COMPLETE_VAL [i]);
+        PORT_WRITE(out_BRANCH_COMPLETE_PREDICTION_UNIT_VAL [i],val);
+        PORT_WRITE(out_BRANCH_COMPLETE_CONTEXT_STATE_VAL   [i],val);
+
+        Tcontrol_t ack = (PORT_READ(in_BRANCH_COMPLETE_PREDICTION_UNIT_ACK [i]) and
+                          PORT_READ(in_BRANCH_COMPLETE_CONTEXT_STATE_ACK   [i]));
+        PORT_WRITE(out_BRANCH_COMPLETE_ACK [i],ack);      
+      }
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_decod.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_decod.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_decod.cpp	(revision 88)
@@ -0,0 +1,40 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::genMealy_decod"
+  void Front_end_Glue::genMealy_decod (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    // Warning : this function is an sc_method if _have_port_context_id
+
+    for (uint32_t i=0; i<_param->_nb_decod_unit; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_decod[i]; ++j)
+        PORT_WRITE(out_DECOD_CONTEXT_ID [i][j],_param->_translate_context_id_from_decod_unit[i][PORT_READ(in_DECOD_DECOD_UNIT_CONTEXT_ID [i][j])]);
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_depth.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_depth.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_depth.cpp	(revision 88)
@@ -0,0 +1,59 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::genMealy_depth"
+  void Front_end_Glue::genMealy_depth (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      {
+        if (_param->_have_port_depth)
+          {
+            Tdepth_t min = PORT_READ(in_DEPTH_PREDICTION_UNIT_MIN [i]);
+            PORT_WRITE(out_DEPTH_CONTEXT_STATE_MIN [i],min);
+            PORT_WRITE(out_DEPTH_MIN               [i],min);
+          }
+
+        PORT_WRITE(out_DEPTH_MAX [i], PORT_READ(in_DEPTH_PREDICTION_UNIT_MAX [i]));
+      }
+
+    for (uint32_t i=0; i<_param->_nb_decod_unit; ++i)
+      for (uint32_t j=0; j<_param->_decod_unit_nb_context[i]; ++j)
+        {
+          uint32_t num_context = _param->_translate_context_id_from_decod_unit[i][j];
+          
+          if (_param->_have_port_depth)
+            {
+          PORT_WRITE(out_CONTEXT_DECOD_UNIT_DEPTH  [i][j], PORT_READ(in_DEPTH_PREDICTION_UNIT_CURRENT [num_context]));
+          PORT_WRITE(out_DEPTH_DECOD_UNIT_MIN      [i][j], PORT_READ(in_DEPTH_PREDICTION_UNIT_MIN     [num_context]));
+            }
+          PORT_WRITE(out_DEPTH_DECOD_UNIT_MAX      [i][j], PORT_READ(in_DEPTH_PREDICTION_UNIT_MAX     [num_context]));
+        }
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 88)
@@ -0,0 +1,76 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::genMealy_event"
+  void Front_end_Glue::genMealy_event (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+    log_function(Front_end_Glue,FUNCTION,_name.c_str());
+
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      {
+        Taddress_t address = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS [i]);
+        PORT_WRITE(out_EVENT_ADDRESS             [i],address);
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS [i],address);
+
+        Taddress_t address_next = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT [i]);
+        PORT_WRITE(out_EVENT_ADDRESS_NEXT             [i],address_next);
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT [i],address_next);
+
+        Tcontrol_t address_next_val = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]);
+        PORT_WRITE(out_EVENT_ADDRESS_NEXT_VAL             [i],address_next_val);
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT_VAL [i],address_next_val);
+
+        Tcontrol_t is_ds_take = PORT_READ(in_EVENT_CONTEXT_STATE_IS_DS_TAKE [i]);
+        PORT_WRITE(out_EVENT_IS_DS_TAKE             [i],is_ds_take);
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_IS_DS_TAKE [i],is_ds_take);
+
+        Tcontrol_t val = PORT_READ(in_EVENT_CONTEXT_STATE_VAL [i]);
+        PORT_WRITE(out_EVENT_VAL             [i],val);
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_VAL [i],val);
+
+        Tcontrol_t ack = (PORT_READ(in_EVENT_ACK             [i]) and
+                          PORT_READ(in_EVENT_IFETCH_UNIT_ACK [i]));
+        PORT_WRITE(out_EVENT_CONTEXT_STATE_ACK [i],ack);
+
+#ifdef DEBUG
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * EVENT Context [%d]",i);
+        if (val and ack)
+          {
+            log_printf(TRACE,Front_end_Glue,FUNCTION,"    * have event");
+            log_printf(TRACE,Front_end_Glue,FUNCTION,"    * address          : %.8x (%.8x)",address     ,address     <<2);
+            log_printf(TRACE,Front_end_Glue,FUNCTION,"    * address_next     : %.8x (%.8x)",address_next,address_next<<2);
+            log_printf(TRACE,Front_end_Glue,FUNCTION,"    * address_next_val : %d",address_next_val);
+            log_printf(TRACE,Front_end_Glue,FUNCTION,"    * is_ds_take       : %d",is_ds_take      );
+          }
+        else
+          log_printf(TRACE,Front_end_Glue,FUNCTION,"    * have not event");
+#endif
+      }
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::statistics_allocation"
+  void Front_end_Glue::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Front_end_Glue",
+		      param_statistics);
+    
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_statistics_deallocation.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::statistics_deallocation"
+  void Front_end_Glue::statistics_deallocation (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    log_printf(INFO,Front_end_Glue,FUNCTION,_("<%s> : Generate Statistics file"),_name.c_str());
+    
+    delete _stat;
+    
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_transition.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_transition.cpp	(revision 88)
@@ -0,0 +1,39 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::transition"
+  void Front_end_Glue::transition (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
+#endif
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl.cpp	(revision 88)
@@ -0,0 +1,48 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+#include "Behavioural/include/Vhdl.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::vhdl"
+  void Front_end_Glue::vhdl (void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    Vhdl * vhdl = new Vhdl (_name);
+
+    _interfaces->set_port(vhdl);
+    _component->vhdl_instance(vhdl);
+
+    vhdl_declaration (vhdl);
+    vhdl_body        (vhdl);
+
+    vhdl->generate_file();
+
+    delete vhdl;
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_body.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_body.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_body.cpp	(revision 88)
@@ -0,0 +1,35 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::vhdl_body"
+  void Front_end_Glue::vhdl_body (Vhdl * & vhdl)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+    vhdl->set_body ("");
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_declaration.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_declaration.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_vhdl_declaration.cpp	(revision 88)
@@ -0,0 +1,34 @@
+#ifdef VHDL
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::vhdl_declaration"
+  void Front_end_Glue::vhdl_declaration (Vhdl * & vhdl)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,102 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Parameters.h"
+#include "Common/include/Max.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::Parameters"
+  Parameters::Parameters (uint32_t                nb_context                           ,
+                          uint32_t                nb_decod_unit                        ,
+                          uint32_t              * nb_inst_decod                        ,
+                          uint32_t                nb_inst_branch_complete              ,
+                          uint32_t              * link_context_to_decod_unit           ,
+                          std::vector<uint32_t> * translate_context_id_from_decod_unit ,
+                          uint32_t                size_address                         ,
+                          uint32_t              * size_depth                           ,
+                          uint32_t              * nb_branch_speculated                 ,
+                          uint32_t                is_toplevel):
+    morpheo::behavioural::Parameters()
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    _nb_context                           = nb_context                          ;
+    _nb_decod_unit                        = nb_decod_unit                       ;
+    _nb_inst_decod                        = nb_inst_decod                       ;
+    _nb_inst_branch_complete              = nb_inst_branch_complete             ;
+    _link_context_to_decod_unit           = link_context_to_decod_unit          ;
+    _translate_context_id_from_decod_unit = translate_context_id_from_decod_unit;
+    _nb_branch_speculated                 = nb_branch_speculated                ;
+
+    _decod_unit_nb_context                = new uint32_t [_nb_decod_unit];
+
+    for (uint32_t i=0; i<_nb_decod_unit; i++)
+      {
+        _decod_unit_nb_context           [i] = translate_context_id_from_decod_unit[i].size();
+      }
+
+    test();
+
+    if (is_toplevel)
+      {
+        _size_context_id          = log2(_nb_context);
+        _size_instruction_address = size_address;
+        _size_depth               = max<uint32_t>(size_depth,_nb_context);
+        
+        _have_port_context_id     = _size_context_id > 0;
+        _have_port_depth          = _size_depth > 0;
+
+        copy ();
+      }
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "Front_end_Glue::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(Front_end_Glue,FUNCTION);
+//     test();
+//     log_end(Front_end_Glue,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::~Parameters"
+  Parameters::~Parameters () 
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    delete [] _decod_unit_nb_context;
+
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+    
+    log_end(Front_end_Glue,FUNCTION);
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,53 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    Parameters_test test ("Front_end_Glue");
+
+    std::vector<uint32_t> translate_context_from_decod_unit [_nb_decod_unit];
+    for (uint32_t i=0; i<_nb_context; ++i)
+      {
+        uint32_t x = _link_context_to_decod_unit[i];
+        if (x < _nb_decod_unit)
+          translate_context_from_decod_unit [x].push_back(i);
+        else
+          test.error(toString(_("context[%d] is linked with an invalid decod_unit.\n"),i));
+      }
+
+    for (uint32_t i=0; i<_nb_decod_unit; ++i)
+      if (translate_context_from_decod_unit [i].size() == 0)
+        test.error(toString(_("decod_unit[%d] is not linked with a ifetch_unit.\n"),i));
+
+    log_end(Front_end_Glue,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,56 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace front_end_glue {
+
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    XML xml ("front_end_glue");
+
+    xml.balise_open("front_end_glue");
+//  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
+    xml.balise_close();
+
+    log_end(Front_end_Glue,FUNCTION);
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Front_end_Glue::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_front_end::front_end::front_end_glue::Parameters & x)
+  {
+    log_begin(Front_end_Glue,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(Front_end_Glue,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace front_end_glue
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Address_management_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/SelfTest/src/main.cpp	(revision 88)
@@ -44,5 +44,7 @@
 	(_nb_instruction               ,
 	 _size_address                 ,
-	 _size_branch_update_prediction);
+	 _size_branch_update_prediction,
+         true // is_toplevel
+         );
       
       msg(_("%s"),param->print(1).c_str());
